
package sub_arctic.lib;

/** 
 * Interactor predicate class that always returns true. 
 * 
 * @see sub_arctic.lib.base_interactor#traverse_and_collect
 * @author Scott Hudson
 */
public class pred_true implements interactor_pred {

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** Perform the predicate "test" by returning true.
   *  
   *  @param obj        the interactor the predicate is testing.
   *  @param parameters the additional parameters (of subclass specific type)
   *                    to the component predicate.
   *  @return true in all cases
   */
  public boolean test(interactor obj, Object parameters) 
    {
      return true;
    }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
