package sub_arctic.lib;

/** 
 * An exception class designed to gather a stack trace for debugging purposes.
 * This is not necessarily thrown because of an, but instead used internally
 * to gather a stack trace for debugging purposes.
 * @author Scott Hudson
 */
public class stack_trace extends sub_arctic_error {

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** Constructor with error message 
   * @param String message the error message associated with the error
   */
  public stack_trace(String message)
    {
      super(message);
    }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** Default constructor */
  public stack_trace()
    {
      super();
    }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
