
package sub_arctic.constraints;

import sub_arctic.lib.interactor;

/** This is a small class that just provides one static method: OBJ() which
 *  returns an ext_objpart_encoding initialized to refer to a given interactor
 *  object.  This exists only to make the creation of external constraints
 *  convenient (i.e., look good as in OTHER.OBJ(some_obj).X()).<p>
 *
 * @author Scott Hudson
 */
public class ext_maker  implements std_encoding_consts {

  /** 
   * Create an ext_objpart_encoding initialized to refer to the given object.
   * This provides a standard dummy part (which happens to be X) which should
   * be replaced by the actual desired part (this would normally be done
   * with one of the factory methods such as Y(), VISIBLE(), or PART(n).  
   * 
   * @param interactor obj the object being referenced
   */
  public static ext_objpart_encoding OBJ(interactor obj)
    {
      /* create an object filling in a dummy standard part */
      return new ext_objpart_encoding(obj, PARTCODE_XY, HORIZONTAL);
    }

}

/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
