package sub_arctic.demo_apps;

/**
 * This is just a little class that represents a mail message.
 */

import java.util.Vector;

public class message {
  String _from;
  public String from() { return _from;}
  String _date;
  public String date() { return _date;}
  String _subject;
  public String subject() { return _subject;}
  String _text;
  public String text() { return _text;}
  String _to;
  public String to() { return _to;}
  /**
   * Must be 0-3 0=from 1=date 2=subject 3=to
   */
  int _display_field=0;
  /**
   * Construct one given the right strings.
   * @param String f from
   * @param String d date
   * @param String s subject
   * @param String t to
   * @param String txt text
   */
  public message(String f, String d, String s, String t, String txt) {
    _from=f;
    _date=d;
    _subject=s;
    _text=txt;
    _to=t;
  }
  /**
   * This method sets which field gets displayed when this object
   * is converted to a string. This is convenient for use with
   * the object_list_element since it will just convert the
   * object to a string. Set this to be a value from 0 to 3
   * 0=from 1=date 2=subject 3=to
   */
  public void set_display_field(int x) {
    switch (x) {
    case 0:
    case 1:
    case 2:
    case 3:
      _display_field=x;
      break;
    default:
      _display_field=0;
      break;
    }
  }
  /**
   * Copy a message object.
   */
  public message copy() {
    return new message(from(),date(),subject(),to(),text());
  }
  /**
   * Convert this message to a string.
   */
  public String toString() {
    switch (_display_field) {
    case 0:
      return from();
    case 1:
      return date();
    case 2:
      return subject();
    case 3:
      return to();
    }
    /* FAIL SAFE */
    return "BAD VALUE IN toString()";
  }
  /**
   * This is how many messages we have hard coded into this file.
   */
  static final int number_messages=11;
  /**
   * Create a bunch of these objects. We just have some hard coded data
   * in here to make things easy.
   *
   * @return Vector a collection of message objects
   */
  public static Vector retreive_messages() {
    Vector result=new Vector();
    String[] f=new String[number_messages];
    String[] to=new String[number_messages];
    String[] s=new String[number_messages];
    String[] d=new String[number_messages];
    String[] text=new String[number_messages];
    int i,count=0;
    /*
     * Construct the messages
     */
f[count]="eugene@cc.gatech.edu (Eugene Liang)";
to[count]="iansmith@Eng";
s[count]="Confirmation";
d[count]="Thu, 15 Aug 1996 17:21:22 -0400 (EDT)";
text[count]=
"\n" +
"Ian,\n" +
"\n" +
"Just want to confirm the Lab Tour tomorrow at 9:00?\n" +
"\n" +
"-Eugene\n" +
"\n" +
"\n" ;
count++;
f[count]="Elizabeth Mynatt <mynatt@parc.xerox.com>";
to[count]="burgess@interval.com, christina@communities.com, colleen.kehoe@Eng";
s[count]="Birthday Celebration for Keith";
d[count]="Thu, 15 Aug 1996 14:52:03 PDT";
text[count]=
"\n" +
"1966 was a busy year as another person in our midst is turning 30\n" +
"in just a few days.  If you would like to help Keith enter into\n" +
"a new decade of his life, please join him for a night of good food,\n" +
"music and company.\n" +
"\n" +
"Details:\n" +
"\n" +
"  Dinner:  The House\n" +
"    Location: 1230 Grant Ave (near Columbus and Cafe Trieste)\n" +
"    Time: 8pm, reservations under \"Keith\"\n" +
"\n" +
"    As reviewed by Patricia Unterman, this \"inexpensive restaurant\n" +
"    combines Asian and Western incredients and techniques... This food\n" +
"    is seriously good.\"\n" +
"\n" +
"    Before 8pm, Keith can likely be found at nearby Cafe Trieste.\n" +
"\n" +
"   Music: Grant and Green's\n" +
"    Following dinner, we're off to hear Jonny Nitro at G&G.\n" +
"\n" +
"Birthday gag gifts are optional.  Since Keith invariably shows up\n" +
"to work on Mondays with a CA \"but it was cloudy\" sunburn, one\n" +
"suggestion is to shower him with different levels of sunblock (4 8\n" +
"15 30 40 45 and 50).  Give a yell if you would like to be assigned\n" +
"your own SPF number.\n" +
"\n" +
"Please RSVP so that I can appropriately modify the dinner reservations.\n" +
"\n" +
"Cheers,\n" +
"Beth\n" +
"\n" +
"\n" +
"\n" +
"\n" ;
count++;
f[count]="colleenk@kehoe (Colleen Kehoe)";
to[count]="tom.rodriguez@eng, iansmith@klimpt";
s[count]="64MB?";
d[count]="Thu, 15 Aug 1996 16:59:23 -0700";
text[count]=
"\n" +
"\n" +
"I finally got around to doing this and I've got twice the memory I\n" +
"thought I had...any clues as to why the machine is so slow?\n" +
"\n" +
"kehoe-273% whatami\n" +
"               DATE: Thu Aug 15 16:55:33 PDT 1996\n" +
"               USER: colleenk\n" +
"           HOSTNAME: le0 = kehoe\n" +
"         IP ADDRESS: le0 = 129.144.152.132\n" +
"              MODEL: SUNW,Sun 4/75\n" +
"    FRAME BUFFER(S): cgsix\n" +
"      SunOS RELEASE: 5.5.1\n" +
"               TYPE: unknown (/=unknown, swap=, /usr=unknown, /home=unknown)\n" +
"             MEMORY: 64MB\n" +
"               SWAP: 193.5MB total, 59.9MB used, 133.6MB available\n" +
"       LOAD AVERAGE: 1.03, 0.42, 0.35\n" +
"     DNS DOMAINNAME: Eng.Sun.COM\n" +
"     NIS DOMAINNAME: DGDO.Eng.Sun.COM\n" +
"    DEFAULT PRINTER: mayday\n" +
"   ETHERNET ADDRESS: 8:0:20:f:2b:13\n" +
"             HOSTID: 5541379e\n" +
"             FLOPPY: fd0 (3.5-inch floppy)\n" +
"\n" +
"----------------------------------------------------------------------\n" +
"Colleen Kehoe (colleen.kehoe@eng.sun.com)\n" +
"\n" +
"\n" +
"\n" +
"\n" ;
count++;

f[count]="ESPNET SportsZone <sportszone1@LISTSERV.STARWAVE.COM>";
to[count]="Multiple recipients of list SPORTSZONE-NEWS";
s[count]="ESPNET Fantasy Football '96 is here...";
d[count]="Fri, 16 Aug 1996 13:29:26 -0700";
text[count]=
"\n" +
"August 16, 1996\n" +
"\n" +
"Greetings ESPNET SportsZone fan,\n" +
"\n" +
"ESPNET SportsZone Fantasy Football '96 is here.  This announcement is being\n" +
"sent to all of our friends including subscribers, participants of past games\n" +
"and contests, and those who specifically requested more information about\n" +
"ESPNET SportsZone Fantasy Football '96.\n" +
"\n" +
"While we are proud of our past games and contests, we think you'll agree\n" +
"that this game has got it all.  Immediate roster updates.  Free unlimited\n" +
"transactions.  Draft aids.  Expert analysis.  Scouting reports.  And one\n" +
"all-inclusive low price ($29.95) for the entire season with no hidden fees.\n" +
"ESPNET SportsZone's Fantasy Football '96 is far and away the best fantasy\n" +
"game anywhere. Whether you are a fantasy rookie or veteran, this is the game\n" +
"for you.\n" +
"\n" +
"If you haven't done so already, take a minute and discover for yourself the\n" +
"exciting features of this year's game.  Simply cut the address below and\n" +
"paste it into your browser:\n" +
"\n" +
"http://espnet.sportszone.com/tour/Fantasy/ffl96/gateway.html\n" +
"\n" +
"But don't delay.  Teams and leagues are forming right now and sign-ups end\n" +
"in less than two weeks.  If you've already registered to play, we thank you\n" +
"and hope you enjoy the football season.\n" +
"\n" +
"The Fantasy Team\n" +
"\n" +
"\n" ;
count++;
f[count]="dhuff@hangtime (Daryl Huff)";
to[count]="iansmith@Eng";
s[count]="CPT IV";
d[count]="Fri, 16 Aug 1996 07:46:20 -0700";
text[count]=
"\n" +
"Try it again.  I had forgotten to add you and Dave to the group file.  I've\n" +
"moved the save date back to Friday 6pm.\n" +
"\n" +
"Daryl\n" +
"\n" +
"> From iansmith@klimpt Thu Aug 15 17:20 PDT 1996\n" +
"> To: dhuff@hangtime (Daryl Huff)\n" +
"> Subject: CPT IV\n" +
"> \n" +
"> I tried logging in and got nowhere due to authorization failure... I\n" +
"> used \"iansmith\" & \"iansmith0\"...\n" +
"> \n" +
"> ian\n" +
"\n" +
"\n" +
"\n" ;
count++;
f[count]="Keith Edwards <kedwards@parc.xerox.com>";
to[count]="subarctic-discuss@cc.gatech.edu";
s[count]="color picker interactor?";
d[count]="Fri, 16 Aug 1996 10:50:59 PDT";
text[count]=
"\n" +
"Has anyone written (or is anyone planning to write) a color picker\n" +
"interactor?  I could use one but may not have the time to get to it\n" +
"for a while...\n" +
"\n" +
"-keith\n" +
"\n" +
"\n" +
"----\n" +
"keith edwards 				\n" +
"xerox palo alto research center\n" +
"\n" +
"\n" ;
count++;
f[count]="Keith Edwards <kedwards@parc.xerox.com>";
to[count]="Ian Smith <iansmith@Eng>";
s[count]="hey";
d[count]="Fri, 16 Aug 1996 10:55:53 PDT";
text[count]=
"\n" +
"Ian Smith writes:\n" +
" > I don't think I can make happy hour today but I would be up for doing\n" +
" > something tonight in SF. Has there ever been any thought of:\n" +
" > \n" +
" > Edinborough Castle?  The theater? Escape from LA? The Crow II?\n" +
" > \n" +
" > ian\n" +
"\n" +
"You know, I could *really* be up for a movie.  What's the best way to\n" +
"track you down?  As usual, I doubt there will be any consensus prior\n" +
"to bar-time.\n" +
"\n" +
"-k\n" +
"\n" +
"----\n" +
"keith edwards 				\n" +
"xerox palo alto research center\n" +
"\n" +
"\n" ;
count++;
f[count]="hudson@cc.gatech.edu (Scott Hudson)";
to[count]="iansmith@cc.gatech.edu";
s[count]="Panner is done";
d[count]="Fri, 16 Aug 1996 16:50:19 -0400 (EDT)";
text[count]=
"\n" +
"\n" +
"OK, panner is done and in.  Part1 now exports the horizontal scrollbar position\n" +
"and part2 does the vertical.  There is now a test/panner_test.\n" +
"\n" +
"Scott\n" +
"\n" +
"\n" +
"\n" ;
count++;
f[count]="debbiev@uselabs (Debbie Vaughan)";
to[count]="online-team-interest@bird, hci-mtv+@hittite, ia-teamleads@infobot";
s[count]="UPDATE - Developer Tools Online Help Usability Study";
d[count]="Fri, 16 Aug 1996 14:14:09 -0700";
text[count]=
"\n" +
"Hi all, \n" +
"\n" +
"I am in the process of recruiting participants for the other time slots,\n" +
"but I wanted to let you know about the participants who have already \n" +
"been recruited so that you could make your observation plans.\n" +
"\n" +
"Thank You,\n" +
"\n" +
"    /\\        Debbie Vaughan, Usability Lab Coordinator\n" +
"   \\\\ \\       SunSoft Usability Labs\n" +
"  \\ \\\\ /      2550 Garcia Avenue, MS: MPK18-107\n" +
" / \\/ / /     Mountain View, CA  94043-1100\n" +
"/ /   \\//\\    \n" +
"\\//\\   / /    Phone:    (415) 786-4669 direct (x84669 - internal)\n" +
" / / /\\ /     Fax:      (415) 786-4096\n" +
"  / \\\\ \\      EMail:   	debbie.vaughan@sun.com\n" +
"   \\ \\\\       \n" +
"    \\/        \n" +
"\n" +
"\n" +
"********************************************************************************\n" +
"\n" +
"\n" +
"USABILITY STUDY SCHEDULE  \n" +
"=========================================\n" +
"PROJECT NAME		IA Online Help\n" +
"STUDY TITLE		Developer Tools Online Help\n" +
"BRIEF DESCRIPTION 	Evaluate and compare Java and C++ developer tools \n" +
"			created at Sun. Come see prototypes and brand new\n" +
" 			products. Use these tools to perform programming tasks \n" +
"			and then provide feedback to improve these tools.  \n" +
"			Study conducted at Sun's Menlo Park campus.		STUDY REPORT #		96-30\n" +
"USABILITY LAB 		MPK18-Lab 3 \n" +
"OBSERVATION LOC.	CntlRm3 1361\n" +
"PILOT DATE		Monday August 19\n" +
"STUDY DATES		Tuesday August 20 - Thursday August 22\n" +
"LENGTH OF STUDY		2 hours per participant\n" +
"REQUESTING COMPANY	IA Online Help team\n" +
"STUDY DOCUMENTATION	Contact Meghan Ede, mede@eng, X84685\n" +
"USABILITY ENGINEER	Scott Joaquim, joaquim@eng, x88636\n" +
"			Meghan Ede, mede@eng, x84685\n" +
"TEST TEAM E-MAIL	online-team-interest@bird, hci-mtv+@hittite,\n" +
"			ia-teamleads@infobot 		  \n" +
"\n" +
"HCI-LAB SET UP TEAM  	\n" +
"	Lab Coordinator - Debbie Vaughan, debbie.vaughan@eng.sun.com, x84669\n" +
"  	Lab Technician  - Scott Stephenson, scott.stephenson@Eng, x84556\n" +
"\n" +
"RECRUITING REQUIREMENTS (including pilot):\n" +
"\n" +
"\n" +
"\n" +
"SCHEDULE OF PARTICIPANTS (to be updated as scheduling is confirmed)\n" +
"======================== \n" +
"Part.#	DAY, DATE		Time	Company/Job Type\n" +
"~~~~~~~	~~~~~~~~~~~~~		~~~~~	~~~~~~~~~~~~~~~~~~~~~\n" +
"\n" +
"\n" +
"\n" +
"P#1	Monday, 8/19		11:00	SUN/SOFTWARE SYSTEMS ENGINEER\n" +
"\n" +
"P#2	Monday, 8/19		 3:00	SUN/SYS. SOFTWARE ENGINEER\n" +
"\n" +
"#1	Tuesday, 8/20		 9:00\n" +
"\n" +
"#2	Tuesday, 8/20		12:30\n" +
"\n" +
"#3	Tuesday, 8/20		 3:00\n" +
"\n" +
"#4	Wednesday, 8/21		 8:30\n" +
"\n" +
"#5	Wednesday, 8/21		 3:30\n" +
"\n" +
"#6	Thursday, 8/22		 8:30\n" +
"\n" +
"#7	Thursday, 8/22		11:00	INDEP. CONTRACTOR/SOFTWARE ENG.\n" +
"\n" +
"#8	Thursday, 8/22		 5:00	SYSTEMS SCIENCE/SR. SOFTWARE ENG.\n" +
"\n" +
"\n" +
"\n" +
"\n" ;
count++;
f[count]="bryce@doppio (Bryce Glass)";
to[count]="iansmith@klimpt";
s[count]="Coming Down?";
d[count]="Fri, 16 Aug 1996 15:27:18 -0700";
text[count]=
"\n" +
"Hey ian -- you coming down today to test your stuff out?\n" +
"\n" +
"--bryce\n" +
"\n" +
"\n" ;
count++;
f[count]="Keith Edwards <kedwards@parc.xerox.com>";
to[count]="subarctic-discuss@cc.gatech.edu";
s[count]="color picker interactor?";
d[count]="Fri, 16 Aug 1996 10:50:59 PDT";
text[count]=
"\n" +
"Has anyone written (or is anyone planning to write) a color picker\n" +
"interactor?  I could use one but may not have the time to get to it\n" +
"for a while...\n" +
"\n" +
"-keith\n" +
"\n" +
"\n" +
"----\n" +
"keith edwards 				\n" +
"xerox palo alto research center\n" +
"\n" +
"\n" ;
count++;

    /*
     * Build the message objects 
     */
    for (i=0; i<number_messages;++i) {
      message m=new message(f[i], d[i], s[i], to[i], text[i]);
      result.addElement(m);
    }
    /*
     * Return 
     */
    return result;
  }

}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
