
package sub_arctic.input;

/** 
 * Input protocol for objects receiving input from the press_inout_drag agent.
 * This agent is a hybrid positional-focus.  It responds to press events
 * over an object, by making that object the inout_drag focus.<p>
 *
 * Note: this adds no new methods to inout_draggable.  We just need the extra
 * interface to differentiate between objects wanting us to handle the press
 * and normal inout_draggable objects.
 *
 * @author Scott Hudson
 */
public interface inout_press_draggable extends inout_draggable {

  /* No extra methods over inout_draggable -- we just need to mark objects 
   * using this via the inout_press_draggable interface name.
   */

}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
