
package sub_arctic.lib;

/** 
 * A (very) simple interactor that does nothing but take up space. 
 *
 * @author Scott Hudson
 */
public class spacer extends base_interactor {
  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** 
   * Full constructor. 
   * @param int xv initial x position of the interactor.
   * @param int yv initial y position of the interactor.
   * @param int wv initial width of the interactor.
   * @param int hv initial height of the interactor.
   */
  public spacer(int xv, int yv, int wv, int hv)
    {
      super(xv,yv,wv,hv);
    }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** 
   * Constructor assuming default position of 0,0.
   * @param int wv initial width of the interactor.
   * @param int hv initial height of the interactor.
   */
  public spacer(int wv, int hv)
    {
      super(0,0,wv,hv);
    }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */

  /** 
   * Constructor assuming default position of 0,0, and (temporary) 
   * default size.  Typically size will be constrained to something. 
   */ 
  public spacer()
    {
      super(0,0,64,64);
    }

  /* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
}
/*=========================== COPYRIGHT NOTICE ===========================

This file is part of the subArctic user interface toolkit.

Copyright (c) 1996 Scott Hudson and Ian Smith
All rights reserved.

The subArctic system is freely available for most uses under the terms
and conditions described in 
  http://www.cc.gatech.edu/gvu/ui/sub_arctic/sub_arctic/doc/usage.html 
and appearing in full in the lib/interactor.java source file.

The current release and additional information about this software can be 
found starting at: http://www.cc.gatech.edu/gvu/ui/sub_arctic/

========================================================================*/
